// ignore_for_file: non_constant_identifier_names, camel_case_extensions

import 'dart:async';
import 'package:galaxeus_lib/extension/extension.dart';
import 'package:telegram_client/telegram_client/scheme/json_dart.dart';
import 'package:telegram_client/telegram_client/telegram_client.dart';

import 'package:telegram_client/telegram_client/scheme/json_dart.dart'
    as scheme;
import 'package:telegram_client/util/util.dart';

/// method GetMessage
extension GetMessageDataOn on TelegramClient {
  /// method GetMessage
  FutureOr<JsonScheme> getMessage({
    required Map parameters,
    required FutureOr<JsonScheme> Function({
      required Map parameters,
    }) callApiInvoke,
    required TelegramClientData telegramClientData,
  }) async {
    dynamic target_chat_id = TgUtils.parse_all_chat_id(parameters: parameters);
    if (target_chat_id is String &&
        RegExp(r"^((@)[a-z0-9_]+)$", caseSensitive: false)
            .hashData(target_chat_id)) {
      var search_public_chat = await callApiInvoke(
        parameters: {
          "@type": "searchPublicChat",
          "username": (target_chat_id)
              .replaceAll(RegExp(r"@", caseSensitive: false), ""),
        },
      );
      if (search_public_chat["@type"] == "chat") {
        parameters["chat_id"] = search_public_chat["id"];
      }
    }
    scheme.JsonScheme message_reply_to = await invoke(
      parameters: {
        "@type": "getMessage",
        "chat_id": parameters["chat_id"],
        "message_id": TgUtils().messageApiToTdlib(parameters["message_id"]),
      },
      telegramClientData: telegramClientData,
    );

    return scheme.JsonScheme(await message_Message(
      message: message_reply_to.rawData,
      telegramClientData: telegramClientData,
      is_skip_reply_message: true,
      is_lite: false,
    ));
  }
}
